Home | Download | Screen shots | Discussion | Documentation
--- | --- | --- | --- | ---

- Main Page
- Namespaces
- Classes
- Files
- Related Pages
- Examples

- Class List
- Class Hierarchy
- Class Members

# openvrml::texture_node Class Reference

`#include <openvrml/node.h>`

Inheritance diagram for openvrml::texture_node:

[legend]

List of all members.

## Detailed Description

Abstract base class for texture nodes.

## Public Member Functions

virtual | ~texture_node ()=0 throw ()
| Destroy.
viewer::texture_object_t | render_texture (viewer &v)
| Insert a texture into a viewer.
virtual const openvrml::image & | image () const =0 throw ()
| The image.
virtual bool | repeat_s () const =0 throw ()
| Get the flag indicating whether the texture should repeat in the S direction.
virtual bool | repeat_t () const =0 throw ()
| Get the flag indicating whether the texture should repeat in the T direction.

## Protected Member Functions

| texture_node (const node_type &type, const boost::shared_ptr< openvrml::scope > &scope) throw ()
| Construct.

## Private Member Functions

virtual texture_node * | to_texture () throw ()
| Cast to a `texture_node`.
virtual viewer::texture_object_t | do_render_texture (viewer &v)
| `render_texture` implementation.

## Private Attributes

boost::mutex | texture_reference_mutex_
| Mutex protecting `texture_reference`.
viewer::texture_object_t | texture_reference
| Identifier for a texture object in the renderer.

## Constructor & Destructor Documentation

openvrml::texture_node::~texture_node | ( |  | ) | throw ()`[pure virtual]`

Destroy.

Todo:
  Proper resource deallocation in the `viewer` depends on the `viewer` not having been decoupled from the `browser`. We need to handle this better via some refcounting scheme.

openvrml::texture_node::texture_node | ( | const node_type & | type,
|  | const boost::shared_ptr< openvrml::scope > & | scope |
| ) |  |  | throw ()`[protected]`

Construct.

Parameters:

  `[in]` | type | the `node_type` associated with the `node`.
  `[in]` | scope | the `scope` the `node` belongs to.

## Member Function Documentation

openvrml::viewer::texture_object_t openvrml::texture_node::render_texture | ( | viewer & | v | ) |

Insert a texture into a viewer.

Parameters:

  `[in,out]` | v | viewer.

Returns:
  object identifier for the inserted texture.

const openvrml::image & openvrml::texture_node::image | ( |  | ) | const throw ()`[pure virtual]`

The image.

Returns:
  the image.

bool openvrml::texture_node::repeat_s | ( |  | ) | const throw ()`[pure virtual]`

Get the flag indicating whether the texture should repeat in the S direction.

Returns:
  `true` if the image should repeat in the S direction, `false` otherwise.

bool openvrml::texture_node::repeat_t | ( |  | ) | const throw ()`[pure virtual]`

Get the flag indicating whether the texture should repeat in the T direction.

Returns:
  `true` if the image should repeat in the T direction, `false` otherwise.

openvrml::texture_node * openvrml::texture_node::to_texture | ( |  | ) | throw ()`[private, virtual]`

Cast to a `texture_node`.

Returns:
  a pointer to this `texture_node`.

Reimplemented from openvrml::node.

openvrml::viewer::texture_object_t openvrml::texture_node::do_render_texture | ( | viewer & | v | ) | `[private, virtual]`

`render_texture` implementation.

Parameters:

  `[in,out]` | v | viewer.

Returns:
  object identifier for the inserted texture.

## Member Data Documentation

boost::mutex openvrml::texture_node::texture_reference_mutex_ `[private]`

Mutex protecting `texture_reference`.

For internal use only.

openvrml::viewer::texture_object_t openvrml::texture_node::texture_reference `[private]`

Identifier for a texture object in the renderer.

For internal use only.